# Typor
# by Eresse <eresse@eresse.net>

# External Includes
require 'aromat'

# Internal Includes
require 'typor/version'
require 'typor/magic'

# Typor Module:
# Root Module for Typor.
module Typor

	# Get File Type:
	# Determines MIME Type of Local File.
	# @param [String] f Path to a File
	# @return [String] MIME Type
	def self.file f
		(Magic.detect_magic(File.read(f)) || []).try :first
	end

	# Get Data Type:
	# Determine MIME Type of Data String.
	# @param [String] d Data String
	# @return [String] MIME Type
	def self.data d
		(Magic.detect_magic(d) || []).try :first
	end
end
